diff --git a/Makefile.am b/Makefile.am
index 797dc6b78fa5..f717d2c2336b 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -361,7 +361,7 @@ man_MANS += doc/org.bluez.Adapter.5 doc/org.bluez.Device.5 \
 		doc/org.bluez.DeviceSet.5 doc/org.bluez.AgentManager.5 \
 		doc/org.bluez.Agent.5 doc/org.bluez.ProfileManager.5 \
 		doc/org.bluez.Profile.5 doc/org.bluez.NetworkServer.5 \
-		doc/org.bluez.Network.5
+		doc/org.bluez.Network.5 doc/org.bluez.Input.5
 man_MANS += doc/org.bluez.Media.5 doc/org.bluez.MediaControl.5 \
 		doc/org.bluez.MediaPlayer.5 doc/org.bluez.MediaFolder.5 \
 		doc/org.bluez.MediaItem.5 doc/org.bluez.MediaEndpoint.5 \
@@ -372,7 +372,7 @@ manual_pages += doc/org.bluez.Adapter.5 doc/org.bluez.Device.5 \
 		doc/org.bluez.DeviceSet.5 doc/org.bluez.AgentManager.5 \
 		doc/org.bluez.Agent.5 doc/org.bluez.ProfileManager.5 \
 		doc/org.bluez.Profile.5 doc/org.bluez.NetworkServer.5 \
-		doc/org.bluez.Network.5
+		doc/org.bluez.Network.5 doc/org.bluez.Input.5
 manual_pages += doc/org.bluez.Media.5 doc/org.bluez.MediaControl.5 \
 		doc/org.bluez.MediaPlayer.5 doc/org.bluez.MediaFolder.5 \
 		doc/org.bluez.MediaItem.5 doc/org.bluez.MediaEndpoint.5 \
@@ -414,13 +414,13 @@ EXTRA_DIST += doc/assigned-numbers.txt doc/supported-features.txt \
 
 EXTRA_DIST += doc/mgmt-api.txt \
 		doc/health-api.txt \
-		doc/sap-api.txt doc/input-api.txt
+		doc/sap-api.txt
 
 EXTRA_DIST += doc/org.bluez.Adapter.rst doc/org.bluez.Device.rst \
 	      doc/org.bluez.DeviceSet.rst doc/org.bluez.AgentManager.rst \
 	      doc/org.bluez.Agent.rst doc/org.bluez.ProfileManager.rst \
 	      doc/org.bluez.Profile.rst doc/org.bluez.NetworkServer.rst \
-	      doc/org.bluez.Network.rst
+	      doc/org.bluez.Network.rst doc/org.bluez.Input.rst
 
 EXTRA_DIST += doc/org.bluez.Media.rst doc/org.bluez.MediaControl.rst \
 		doc/org.bluez.MediaPlayer.rst doc/org.bluez.MediaFolder.rst \
diff --git a/doc/input-api.txt b/doc/input-api.txt
deleted file mode 100644
index 67da08b102c9..000000000000
--- a/doc/input-api.txt
+++ /dev/null
@@ -1,32 +0,0 @@
-BlueZ D-Bus Input API description
-*********************************
-
-Input hierarchy
-===============
-
-Service		org.bluez
-Interface	org.bluez.Input1
-Object path	[variable prefix]/{hci0,hci1,...}/dev_XX_XX_XX_XX_XX_XX
-
-Properties	string ReconnectMode [readonly]
-
-			Determines the Connectability mode of the HID device as
-			defined by the HID Profile specification, Section 5.4.2.
-
-			This mode is based in the two properties
-			HIDReconnectInitiate (see Section 5.3.4.6) and
-			HIDNormallyConnectable (see Section 5.3.4.14) which
-			define the following four possible values:
-
-			"none"		Device and host are not required to
-					automatically restore the connection.
-
-			"host"		Bluetooth HID host restores connection.
-
-			"device"	Bluetooth HID device restores
-					connection.
-
-			"any"		Bluetooth HID device shall attempt to
-					restore the lost connection, but
-					Bluetooth HID Host may also restore the
-					connection.
diff --git a/doc/org.bluez.Input.rst b/doc/org.bluez.Input.rst
new file mode 100644
index 000000000000..c3c223c913d8
--- /dev/null
+++ b/doc/org.bluez.Input.rst
@@ -0,0 +1,51 @@
+===============
+org.bluez.Input
+===============
+
+-----------------------------------
+BlueZ D-Bus Input API documentation
+-----------------------------------
+
+:Version: BlueZ
+:Date: October 2023
+:Manual section: 5
+:Manual group: Linux System Administration
+
+Interface
+=========
+
+:Service:	org.bluez
+:Interface:	org.bluez.Input1
+:Object path:	[variable prefix]/{hci0,hci1,...}/dev_XX_XX_XX_XX_XX_XX
+
+Properties
+----------
+
+string ReconnectMode [readonly]
+```````````````````````````````
+
+	Indicates the Connectability mode of the HID device as defined by the
+	HID Profile specification, Section 5.4.2.
+
+	This mode is based in the two properties HIDReconnectInitiate (see
+	Section 5.3.4.6) and HIDNormallyConnectable (see Section 5.3.4.14) which
+	define the following four possible values:
+
+	:"none":
+
+		Device and host are not required to automatically restore the
+		connection.
+
+	:"host":
+
+		Bluetooth HID host restores connection.
+
+	:"device":
+
+		Bluetooth HID device restores connection.
+
+	:"any":
+
+		Bluetooth HID device shall attempt to restore the lost
+		connection, but Bluetooth HID Host may also restore the
+		connection.